module Expr  where

data Expr = 
    Const Int
  | Add (Expr,Expr)
  | Mult (Expr,Expr)


fold f0 f1 f2 (Const i)     = f0 i
  
fold f0 f1 f2 (Add (e1,e2)) = f1 (((fold f0) f1) f2 e1) (((fold f0) f1) f2 e2)

fold f0 f1 f2 (Mult (e1,e2)) = f2 (((fold f0) f1) f2 e1) (((fold f0) f1) f2 e2)

e1 = Add (Mult (Const 1,Const 2),Const 3)
e2 = Add (Add (Const 0,Const 1),Const 2)