module Expr  where

data Expr = 
    Const Int
  | Add (Expr,Expr)


fold f0 f1 (Const i)     = f0 i
  
fold f0 f1 (Add (e1,e2)) = f1 (((fold f0) f1) e1) (((fold f0) f1) e2)

e1 = Add (Add (Const 1,Const 2),Const 3)
e2 = Add (Add (Const 0,Const 1),Const 2)