module Client where 

import Expr
import ConstMod (check,pos,toString,eval)
import AddMod (check,pos,toString,eval)
import MultMod (check,pos,toString,eval)
import DivMod (check,pos,toString,eval)

r1 = print (if Client.pos e1 && Client.check e1 then Client.toString e1 else "invalid expression")

check x
    =
        Expr.checkskeleton ConstMod.check AddMod.check
            MultMod.check
            DivMod.check
            x

  
pos x
    = fold ConstMod.pos AddMod.pos MultMod.pos DivMod.pos x


toString x
    =
        fold ConstMod.toString AddMod.toString
            MultMod.toString
            DivMod.toString
            x

r2 = print (show (Client.eval e1))

eval x
    =
        Expr.fold ConstMod.eval AddMod.eval MultMod.eval DivMod.eval
            x

  
r3 = print (Client.toString e2)
r4 = print (show (Client.eval e2))
