module Expr  where

data Expr = 
    Const Int
  | Add (Expr,Expr)
  | Mult (Expr,Expr)
  | Div (Expr,Expr)






checkskeleton f0 f1 f2 f3 ((Const i)) = f0
  
checkskeleton f0 f1 f2 f3 ((Add (e1, e2))) = f1 (((((checkskeleton f0) f1) f2) f3) e1) (((((checkskeleton f0) f1) f2) f3) e2)
  
checkskeleton f0 f1 f2 f3 ((Mult (e1, e2)))
    = f2 (((((checkskeleton f0) f1) f2) f3) e1) (((((checkskeleton f0) f1) f2) f3) e2)
  
checkskeleton f0 f1 f2 f3 ((Div (e1, e2))) = f3 e2 (((((checkskeleton f0) f1) f2) f3) e1) (((((checkskeleton f0) f1) f2) f3) e2)



fold f0 f1 f2 f3 ((Const i)) = f0 i
  
fold f0 f1 f2 f3 ((Add (e1, e2)))
    = f1 (((((fold f0) f1) f2) f3) e1) (((((fold f0) f1) f2) f3) e2)
  
fold f0 f1 f2 f3 ((Mult (e1, e2)))
    = f2 (((((fold f0) f1) f2) f3) e1) (((((fold f0) f1) f2) f3) e2)
  
fold f0 f1 f2 f3 ((Div (e1, e2)))
    = f3 (((((fold f0) f1) f2) f3) e1) (((((fold f0) f1) f2) f3) e2)

e1 = Add (Mult (Const 1,Const 2),Const 3)
e2 = Add (Div (Const 0,Const 1),Const 2)