module Client where 

import Expr
import ConstMod (pos,toString,eval)
import AddMod (pos,toString,eval)
import MultMod (pos,toString,eval)
import DivMod (pos,toString,eval)



r1 = print (if Client.pos e1 then Client.toString e1 else "negative integers")

pos x = fold ConstMod.pos AddMod.pos MultMod.pos DivMod.pos x  

  
toString x
    =
        fold ConstMod.toString AddMod.toString
            MultMod.toString DivMod.toString
            x

r2 = print (show (Client.eval e1))

eval x = Expr.fold ConstMod.eval AddMod.eval MultMod.eval DivMod.eval x

  
r3 = print (Client.toString e2)
r4 = print (show (Client.eval e2))
